=== debian/changelog ===
tcc (0.9.27+git20200814.62c30a4a-2) unstable; urgency=medium

  * Team upload (Debian namespace).

  [ Chris Hofstaedtler ]
  * Correct Vcs-Git URL
  * Fix FTBFS with gcc-14 (Closes: #1075552)
  * self-hosting test: set allow-stderr for warnings

  [ Thomas Preud'homme ]
  * debian/rules: Use DEB_HOST_ARCH_CPU rather than DEB_HOST_ARCH to set
    HOST_CPU (Thanks John Scott).

  [ John Scott ]
  * Add a DEP-8 test checking that tcc self-compiles.

  [ Debian Janitor ]
  * Fix field name typo in debian/copyright (Comments => Comment).
  * Update standards version to 4.5.1, no changes needed.

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 10 Aug 2024 12:16:58 +0200

tcc (0.9.27+git20200814.62c30a4a-1) unstable; urgency=medium

  * New upstream snapshot (Closes: #964224, #925127, #929872):
    + fixes CVE-2019-9754 and CVE-2019-12495.
  * debian/patches:
    + Enable VFP if targeting armhf.
    + Drop patches applied upstream.
  * debian/rules:
    + Remove unneeded backup of tcc-doc.html.
  * debian/control:
    + Bump debhelper compat to 13 and build-depends on debhelper-compat.
    + Point to mob branch on Vcs-Git field.
    + Bump Standards-Version to 4.5.0 (no changes needed).
    + Set Rules-Requires-Root to no.
  * debian/compat:
    + Remove.
  * debian/rules:
    + Strip bcheck.o not stripped by dh_strip.
  * debian/upstream/metadata:
    + Add upstream metadata.

 -- Thomas Preud'homme <robotux@debian.org>  Fri, 14 Aug 2020 23:32:44 +0100

tcc (0.9.27-8) unstable; urgency=medium

  * debian/rules:
    + Fix --cpu value to pass to configure for arm64 host.

 -- Thomas Preud'homme <robotux@debian.org>  Thu, 15 Mar 2018 00:43:04 +0000

tcc (0.9.27-7) unstable; urgency=medium

  * debian/rules:
    + Set host CPU based on Debian architecture to ensure reproducible build.
    + Fix retrieval of DEB_HOST_MULTIARCH for i386 host (Closes: #892899).
    + Remove useless echo.

 -- Thomas Preud'homme <robotux@debian.org>  Wed, 14 Mar 2018 23:49:20 +0000

tcc (0.9.27-6) unstable; urgency=medium

  * debian/rules:
    + Simplify Debian architecture check.
    + Enable build of i386 tcc cross-compiler (Closes: #673380).
    + Remove build and clean overrides useless since debhelper 10.
    + Link i386-tcc manual to tcc manual.
    + Use architecture-dependent overrides.
    + Restore tcc-doc.html in clean target.

 -- Thomas Preud'homme <robotux@debian.org>  Fri, 09 Mar 2018 21:45:23 +0000
