=== debian/tests/control ===
Tests: self-hosting
Depends: tcc, make, texinfo, libc-dev
Restrictions: allow-stderr
